windows/src/samba.sh

104 lines
2.8 KiB
Bash
Raw Permalink Normal View History

2024-02-07 23:48:38 +01:00
#!/usr/bin/env bash
set -Eeuo pipefail
: "${SAMBA:="Y"}"
[[ "$SAMBA" == [Nn]* ]] && return 0
[[ "$NETWORK" == [Nn]* ]] && return 0
2024-02-07 23:48:38 +01:00
hostname="host.lan"
interface="dockerbridge"
2024-02-07 23:48:38 +01:00
if [[ "$DHCP" == [Yy1]* ]]; then
hostname="$IP"
interface="$VM_NET_DEV"
fi
2024-05-05 21:24:47 +02:00
share="/shared"
if [ ! -d "$share" ] && [ -d "$STORAGE/shared" ]; then
share="$STORAGE/shared"
fi
2024-02-07 23:48:38 +01:00
mkdir -p "$share"
if [ -z "$(ls -A "$share")" ]; then
chmod 777 "$share"
{ echo "--------------------------------------------------------"
echo " $APP for Docker v$(</run/version)..."
echo " For support visit $SUPPORT"
echo "--------------------------------------------------------"
echo ""
echo "Using this folder you can share files with the host machine."
echo ""
echo "To change its location, include the following bind mount in your compose file:"
echo ""
echo " volumes:"
echo " - \"/home/user/example:/shared\""
echo ""
echo "Or in your run command:"
echo ""
echo " -v \"/home/user/example:/shared\""
echo ""
echo "Replace the example path /home/user/example with the desired shared folder."
echo ""
} | unix2dos > "$share/readme.txt"
fi
2024-02-07 23:48:38 +01:00
{ echo "[global]"
echo " server string = Dockur"
echo " netbios name = $hostname"
2024-02-07 23:48:38 +01:00
echo " workgroup = WORKGROUP"
echo " interfaces = $interface"
2024-02-07 23:48:38 +01:00
echo " bind interfaces only = yes"
echo " security = user"
echo " guest account = nobody"
echo " map to guest = Bad User"
echo " server min protocol = NT1"
2024-02-07 23:48:38 +01:00
echo ""
echo " # disable printing services"
echo " load printers = no"
echo " printing = bsd"
echo " printcap name = /dev/null"
echo " disable spoolss = yes"
echo ""
echo "[Data]"
echo " path = $share"
2024-02-07 23:48:38 +01:00
echo " comment = Shared"
echo " writable = yes"
echo " guest ok = yes"
echo " guest only = yes"
echo " force user = root"
echo " force group = root"
} > "/etc/samba/smb.conf"
2024-02-07 23:48:38 +01:00
if ! smbd; then
error "Samba daemon failed to start!"
smbd -i --debug-stdout || true
fi
2024-05-28 18:20:27 +02:00
legacy=""
if [ -f "$STORAGE/windows.old" ]; then
MT=$(<"$STORAGE/windows.old")
2024-05-28 18:20:27 +02:00
[[ "${MT,,}" == "pc-q35-2"* ]] && legacy="y"
[[ "${MT,,}" == "pc-i440fx-2"* ]] && legacy="y"
fi
2024-05-28 18:20:27 +02:00
if [ -n "$legacy" ]; then
# Enable NetBIOS on Windows XP and lower
if ! nmbd; then
error "NetBIOS daemon failed to start!"
nmbd -i --debug-stdout || true
fi
else
2024-05-28 18:20:27 +02:00
# Enable Web Service Discovery on Vista and up
wsdd -i "$interface" -p -n "$hostname" &
2024-05-04 13:28:12 +02:00
echo "$!" > /var/run/wsdd.pid
fi
2024-02-07 23:48:38 +01:00
return 0